Subject: Re: [sfc] New Version Notification for draft-ietf-sfc-multi-layer-oam-03.txt
From: "Carlos Pignataro (cpignata)" <[email-masked]>
To: Greg Mirsky <[email-masked]>
Cc: Service Function Chaining IETF list <[email-masked]>
Date: Sat, 11 May 2019 03:34:45 +0000
List-Id: Network Service Chaining <sfc.ietf.org>

Dear SFC Chairs,

I believe Greg’s response is mis-representing my position, and mis-quoting what I wrote, as follows:

Greg wrote:
Thus I'm puzzled why are you demanding that this optional section be added to the draft now?

1. I am not demanding. Instead I wrote:
Request: Can we please add an “Implementation Status” section?

Greg wrote:
Thus I'm puzzled why are you demanding that this optional section be added to the draft now?

However, I suggested this over a year ago, and then 6 months ago, as per the list posting included below. Not “now”.
* March 29, 2018, on draft-wang-sfc-multi-layer-oam https://mailarchive.ietf.org/arch/msg/nvo3/eNRV-7GLWO_lLeeXwI97HhTrtBo
* October 27, 2018, on adoption https://mailarchive.ietf.org/arch/msg/sfc/wuK4MiyeOMNbXrRIYjiW7zCtZ70

My main request is that on-list comments and suggestions are responded to and discussed on technical merits. The previous two/three times, my comment was ignored and not responded to.

I also do not understand why questions are selectively ignored. I asked three questions on this email, but received a response to only one.

Dear Greg,

Sorry to have puzzled you. That was not the intention. The intention was to engage in a technical discussion about an Internet Best Current Practice.

Apologies if I sounded (or was) repetitive, just seeking an answer.

I understand the “Implementation Status” section is optional, but since Internet documents are (among other things) for interoperability, I kindly request you consider adding that optional section. Besides the one-liner you quoted, RFC 7942 goes into great lengths at explaining the importance of doing so.

You also mention:
Yes, the work on the implementation is ongoing

Does this mean “the implementation” as in only one?

Best,

— Carlos Pignataro

On May 10, 2019, at 11:14 PM, Greg Mirsky <[email-masked]<mailto:[email-masked]>> wrote:

Hi Carlos,
I'm sure you've read the section "Implementation Status" in RFC 7942 that opens with the following sentence:
   Each Internet-Draft may contain a section entitled "Implementation Status".
Thus I'm puzzled why are you demanding that this optional section be added to the draft now? Yes, the work on the implementation is ongoing and when there will be updates, we'll certainly share them with the WG.

Regards,
Greg

On Fri, May 10, 2019 at 7:53 PM Carlos Pignataro (cpignata) <[email-masked]<mailto:[email-masked]>> wrote:
Hi, Greg, SFC,

In order to understand the positioning of draft-ietf-sfc-multi-layer-oam, please find 3 high-level yet very important questions and associated comments for consideration.

To avoid potential misinterpretation and to be explicit on this note's intention: this email does not imply interest in this draft, does not mean support, I have not read the document fully.

But a quick note for completeness:

1. “Implementation Status” Section.

The authors seem to selectively respond to comments.

I asked for an “Implementation Status” Section [RFC7942] at least two or three times:
* March 29, 2018, on draft-wang-sfc-multi-layer-oam https://mailarchive.ietf.org/arch/msg/nvo3/eNRV-7GLWO_lLeeXwI97HhTrtBo
* October 27, 2018, on adoption https://mailarchive.ietf.org/arch/msg/sfc/wuK4MiyeOMNbXrRIYjiW7zCtZ70

Instead, this drafts seems to be inventing a full blown protocol without implementation practice.

SFC Chairs, could we please follow-up on repeated comments made on the list and track a disposition? These are over a year old, and part of an adoption call.

Request: Can we please add an “Implementation Status” section?

2. New protocol invention outside of / rogue to an SFC OAM Framework.

draft-ietf-sfc-multi-layer-oam does not reference any other SFC I-Ds. It does not build upon existing work in progress, and instead invents a new protocol with RFC8300 as the only Normative reference from SFC.

The draft-ietf-sfc-oam-framework at https://tools.ietf.org/html/draft-ietf-sfc-oam-framework-06 takes a holistic approach of including an analysis (selecting only some section titles):
4.  SFC OAM Functions . . . . . . . . . . . . . . . . . . . . . .   8
5.  Gap Analysis  . . . . . . . . . . . . . . . . . . . . . . . .  11
5.1.  Existing OAM Functions  . . . . . . . . . . . . . . . . .  11
5.2.  Missing OAM Functions . . . . . . . . . . . . . . . . . .  12
6.4.  OAM Toolset applicability . . . . . . . . . . . . . . . .  13
       6.4.1.  ICMP Applicability  . . . . . . . . . . . . . . . . .  13

This analysis ought to guide protocol definition.

Question: Can this draft consider existing protocols and gap performed before re-inventing? Specifically Normatively cite the SFC OAM Framework and see where reuse is best?

3. Existing implementation of OAM functions.

Hows does this draft work with existing OAM functions with existing implementation, such as https://tools.ietf.org/html/draft-penno-sfc-trace-03 ? The fact that the draft is expired does not mean the implementation is uncoded.

Many thanks,

— Carlos Pignataro

On May 9, 2019, at 1:31 AM, Greg Mirsky <[email-masked]<mailto:[email-masked]>> wrote:

Dear All,
the update to the draft addresses the comment received from Joel at the meeting in Prague:
- Joel: if we get an echo request we can't parse, how do we know that it is an echo request, and do we have the information to return it to the correct source?
- Greg: we will clarify this in the draft. It has to practical so the sender can understand the situation.. We introduced two classes of TLVs: mandatory and optional. Will add clearer text.

A new TLV, Errored TLVs, introduced to be optionally used to pass in an echo reply mandatory TLVs that were not understood because either the implementation on the receiver does not support them or couldn't parse them correctly.

Also, please review the update to the interpretation of O-bit and the value of the Next Protocol field to address Adrian's comments at the meeting in Bangkok:
The rules of
   interpreting the values of O bit and the Next Protocol field are as
   follows:

   o  O bit set, and the Next Protocol value is not one of identifying
      active or hybrid OAM protocol (per [RFC7799] definitions), e.g.,
      defined in this specification Active SFC OAM - a Fixed-Length
      Context Header or Variable-Length Context Header(s) contain OAM
      command or data.  and the type of payload determined by the Next
      Protocol field;

   o  O bit set, and the Next Protocol value is one of identifying
      active or hybrid OAM protocol - the payload that immediately
      follows SFC NSH contains OAM command or data;

   o  O bit is clear - no OAM in a Fixed-Length Context Header or
      Variable-Length Context Header(s) and the payload determined by
      the value of the Next Protocol field;

   o  O bit is clear and the Next Protocol value is one of identifying
      active or hybrid OAM protocol MUST be identified and reported as
      the erroneous combination.  An implementation MAY have control to
      enable processing of the OAM payload.

   From the above-listed rules follows the recommendation to avoid
   combination of OAM in a Fixed-Length Context Header or Variable-
   Length Context Header(s) and in the payload immediately following the
   SFC NSH because there is no unambiguous way to identify such
   combination using the O bit and the Next Protocol field.

Regards,
Greg

---------- Forwarded message ---------
From: <[email-masked]<mailto:[email-masked]>>
Date: Wed, May 8, 2019 at 10:21 PM
Subject: New Version Notification for draft-ietf-sfc-multi-layer-oam-03.txt
To: <[email-masked]<mailto:[email-masked]>>, Gregory Mirsky <[email-masked]<mailto:[email-masked]>>, Bhumip Khasnabish <[email-masked]<mailto:[email-masked]>>, Wei Meng <[email-masked]<mailto:meng.wei2@zte..com.cn>>, Cui(Linda) Wang <[email-masked]<mailto:[email-masked]>>

A new version of I-D, draft-ietf-sfc-multi-layer-oam-03.txt
has been successfully submitted by Greg Mirsky and posted to the
IETF repository.

Name:           draft-ietf-sfc-multi-layer-oam
Revision:       03
Title:          Active OAM for Service Function Chains in Networks
Document date:  2019-05-08
Group:          sfc
Pages:          18
URL:            https://www.ietf.org/internet-drafts/draft-ietf-sfc-multi-layer-oam-03.txt
Status:         https://datatracker.ietf.org/doc/draft-ietf-sfc-multi-layer-oam/
Htmlized:       https://tools.ietf.org/html/draft-ietf-sfc-multi-layer-oam-03
Htmlized:       https://datatracker.ietf.org/doc/html/draft-ietf-sfc-multi-layer-oam
Diff:           https://www.ietf.org/rfcdiff?url2=draft-ietf-sfc-multi-layer-oam-03

Abstract:
   A set of requirements for active Operation, Administration and
   Maintenance (OAM) of Service Function Chains (SFCs) in networks is
   presented.  Based on these requirements an encapsulation of active
   OAM message in SFC and a mechanism to detect and localize defects
   described.  Also, this document updates RFC 8300 in the definition of
   O (OAM) bit in the Network Service Header (NSH) and defines how the
   active OAM message identified in SFC NSH.

Please note that it may take a couple of minutes from the time of submission
until the htmlized version and diff are available at tools.ietf.org<http://tools.ietf.org/>.

The IETF Secretariat

_______________________________________________
sfc mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/sfc